<?php

namespace Gravity_Flow\Gravity_Flow\Blocks\Endpoints\Inbox_Entries;

use Gravity_Flow\Gravity_Flow\Ajax\Argument;
use Gravity_Flow\Gravity_Flow\Ajax\Config as Ajax_Config;

class Config extends Ajax_Config {

	const FORM_IDS       = 'form-ids';
	const ID_COLUMN      = 'id-column';
	const ACTIONS_COLUMN = 'actions-column';
	const LAST_UPDATED   = 'last-updated';
	const DUE_DATE       = 'due-date';
	const FIELDS         = 'fields';

	protected $name = 'inbox-entries';

	public function args() {
		return array(
			$this->form_ids(),
			$this->id_column(),
			$this->actions_column(),
			$this->last_updated(),
			$this->due_date(),
			$this->fields(),
		);
	}

	public function form_ids() {
		return new Argument(
			self::FORM_IDS,
			false,
			''
		);
	}

	public function id_column() {
		return new Argument(
			self::ID_COLUMN,
			false,
			''
		);
	}

	public function actions_column() {
		return new Argument(
			self::ACTIONS_COLUMN,
			false,
			''
		);
	}

	public function last_updated() {
		return new Argument(
			self::LAST_UPDATED,
			false,
			''
		);
	}

	public function due_date() {
		return new Argument(
			self::DUE_DATE,
			false,
			''
		);
	}

	public function fields() {
		return new Argument(
			self::FIELDS,
			false,
			array()
		);
	}
}