<?php

namespace Gravity_Flow\Gravity_Flow\Blocks\Endpoints\Inbox_Form_Steps;

use Gravity_Flow\Gravity_Flow\Ajax\Endpoint as Ajax_Endpoint;
use \GFAPI;

class Endpoint extends Ajax_Endpoint {

	public function permission_callback( $request ) {
		return GFAPI::current_user_can_any( array( 'gravityflow_reports' ) );
	}

	public function handle( $request ) {
		$steps = gravity_flow()->get_steps( $request['id'] );

		$_steps = array();
		foreach ( $steps as $step ) {
			$assignees     = $step->get_assignees();
			$assignee_vars = array();

			foreach ( $assignees as $assignee ) {
				$assignee_id = $assignee->get_id();
				if ( ! empty( $assignee_id ) ) {
					$assignee_vars[] = array(
						'key'  => $assignee->get_key(),
						'name' => $assignee->get_display_name(),
					);
				}
			}

			$_steps[ $step->get_id() ] = array(
				'id'        => $step->get_id(),
				'name'      => $step->get_name(),
				'assignees' => $assignee_vars,
			);
		}

		return $this->response_factory->create( $_steps, 200 );
	}

}