<?php

namespace Gravity_Flow\Gravity_Flow\Blocks\Endpoints\Reports;

use Gravity_Flow\Gravity_Flow\Ajax\Argument;
use Gravity_Flow\Gravity_Flow\Ajax\Config as Ajax_Config;

class Config extends Ajax_Config {

	const ASSIGNEE       = 'assignee';
	const RANGE          = 'range';
	const FORM           = 'form';
	const CATEGORY       = 'category';
	const STEP_ID        = 'step-id';
	const DISPLAY_FILTER = 'display_filter';

	protected $name = 'workflow/reports';

	public function args() {
		return array(
			$this->assignee(),
			$this->range(),
			$this->form(),
			$this->category(),
			$this->step_id(),
			$this->display_filter(),
		);
	}

	public function assignee() {
		return new Argument(
			self::ASSIGNEE,
			false,
			''
		);
	}

	public function range() {
		return new Argument(
			self::RANGE,
			false,
			''
		);
	}

	public function form() {
		return new Argument(
			self::FORM,
			false,
			''
		);
	}

	public function category() {
		return new Argument(
			self::CATEGORY,
			false,
			''
		);
	}

	public function step_id() {
		return new Argument(
			self::STEP_ID,
			false,
			''
		);
	}

	public function display_filter() {
		return new Argument(
			self::DISPLAY_FILTER,
			false,
			''
		);
	}
}