<?php

namespace Gravity_Flow\Gravity_Flow\Inbox\Endpoints\Get_Preference;

use Gravity_Flow\Gravity_Flow\Ajax\Argument;
use Gravity_Flow\Gravity_Flow\Ajax\Config as Ajax_Config;

class Config extends Ajax_Config {

	const KEY     = 'key';
	const TYPE    = 'type';
	const USER_ID = 'user_id';
	const VIEW    = 'view';

	const DEFAULT_VIEW  = 'inbox';
	const DEFAULT_VALUE = 'default';

	const DEFAULT_TYPE = 'cascade';

	protected $name = 'inbox/preferences';

	public function args() {
		return array(
			$this->key(),
			$this->type(),
			$this->id(),
			$this->view(),
			$this->default_value(),
		);
	}

	public function key() {
		return new Argument(
			self::KEY,
			true
		);
	}

	public function type() {
		return new Argument(
			self::TYPE,
			false,
			self::DEFAULT_TYPE
		);
	}

	public function id() {
		return new Argument(
			self::USER_ID,
			false,
			0
		);
	}

	public function view() {
		return new Argument(
			self::VIEW,
			false,
			self::DEFAULT_VIEW
		);
	}

	public function default_value() {
		return new Argument(
			self::DEFAULT_VALUE,
			false,
			''
		);
	}
}