<?php

namespace Gravity_Flow\Gravity_Flow\Inbox\Endpoints\Get_Preference;

use Gravity_Flow\Gravity_Flow\Ajax\Endpoint as Ajax_Endpoint;
use Gravity_Flow\Gravity_Flow\Inbox\Models\Preferences;

class Endpoint extends Ajax_Endpoint {

	public function permission_callback( $request ) {
		return current_user_can( 'administrator' );
	}

	public function handle( $request ) {
		$key     = $request->get_param( Config::KEY );
		$type    = $request->get_param( Config::TYPE );
		$id      = $request->get_param( Config::USER_ID );
		$view    = $request->get_param( Config::VIEW );
		$default = $request->get_param( Config::DEFAULT_VALUE );

		$id_or_view = $type === 'user' ? $id : $view;
		$data       = $type === Config::DEFAULT_TYPE ? $this->model->get_setting( $key, $id, $view, $default ) : $this->model->get_setting_from( $type, $key, $id_or_view, $default );

		return $this->response_factory->create( $data, 200 );
	}

}