<?php

namespace Gravity_Flow\Gravity_Flow\Inbox\Endpoints\Save_Preference;

use Gravity_Flow\Gravity_Flow\Ajax\Argument;
use Gravity_Flow\Gravity_Flow\Ajax\Config as Ajax_Config;

class Config extends Ajax_Config {

	const KEY     = 'key';
	const VALUE   = 'value';
	const TYPE    = 'type';
	const USER_ID = 'user_id';
	const VIEW    = 'view';

	const DEFAULT_VIEW = 'inbox';
	const DEFAULT_TYPE = 'view';

	protected $name = 'inbox/preferences';

	public function method() {
		return 'PUT';
	}

	public function args() {
		return array(
			$this->key(),
			$this->value(),
			$this->type(),
			$this->id(),
			$this->view(),
		);
	}

	public function key() {
		return new Argument(
			self::KEY,
			true
		);
	}

	public function value() {
		return new Argument(
			self::VALUE,
			true
		);
	}

	public function type() {
		return new Argument(
			self::TYPE,
			false,
			self::DEFAULT_TYPE
		);
	}

	public function id() {
		return new Argument(
			self::USER_ID,
			false,
			0
		);
	}

	public function view() {
		return new Argument(
			self::VIEW,
			false,
			self::DEFAULT_VIEW
		);
	}
}