<?php

namespace Gravity_Flow\Gravity_Flow\Inbox\Endpoints\Save_Preference;

use Gravity_Flow\Gravity_Flow\Ajax\Endpoint as Ajax_Endpoint;
use Gravity_Flow\Gravity_Flow\Inbox\Models\Preferences;

class Endpoint extends Ajax_Endpoint {

	public function permission_callback( $request ) {
		return current_user_can( 'administrator' );
	}

	public function handle( $request ) {
		$key   = $request->get_param( Config::KEY );
		$value = $request->get_param( Config::VALUE );
		$type  = $request->get_param( Config::TYPE );
		$id    = $request->get_param( Config::USER_ID );
		$view  = $request->get_param( Config::VIEW );

		$save = $this->model->save_setting( $key, $id, $value, $type, $view );
		$data = array( 'success' => true );

		return $this->response_factory->create( $data, 200 );
	}

}